<?php
/**
 * @version     1.1
 * @package     plg_idcomlogapi - PUT Hikashop order data to ID Commerce API for Logistics processing
 * @copyright   Copyright (C) 2015. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Mike Hill <mikehill@joomlasales.com> - http://joomlasales.com
 */


// No direct access
defined('_JEXEC') or die;

/**
 * @package		Joomla.Plugin
 * @subpackage	User.joomla
 * @since		2.5
 */
class plgHikashopIdComLogApi extends JPlugin
{
	/**
	 * Constructor
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param	array	$config  An array that holds the plugin configuration
	 * @since	1.0
	 */
  function plgHikashopIdComLogApi(&$subject, $config){
      parent::__construct($subject, $config);
  }

  // Call a trigger, in this example: onBeforeOrderCreate
  /*function onBeforeOrderCreate(&$order,&$send_email) {
    // Actions to do when my trigger is called
      //$this->logErrorDB('onBeforeOrderCreate order: '.json_encode($order));

  } */

  /**
  * the plugin event which will be triggered in hikashop immediately after an order is created
  * 
  * @param $order - (stdClass) - data related to the order that just occured
  * @since  1.0
  */
  /*function onAfterOrderCreate(&$order) {
      $settings = $this->getArtIDComLogApiSettings();

      require JPATH_BASE.'/plugins/hikashop/idcomlogapi/idcomlogapi.class.php';
      $idComLogApi = new IdComLogApi($settings);

      $json = $idComLogApi->assembleJsonOrder($order); //organize data into required structure
      
      $count = 0;
      while ($response == false) {
        if ($count >= 50) {
          break;
        } else {
          $response = $idComLogApi->execute($json,'Orders');
          //var_dump($response);die();     
        }
        $count++;  
      }
      
  } */

  /*function onAfterOrderConfirm(&$order,&$methods,$method_id) {

      $settings = $this->getArtIDComLogApiSettings();

      require JPATH_BASE.'/plugins/hikashop/idcomlogapi/idcomlogapi.class.php';
      $idComLogApi = new IdComLogApi($settings);

      $json = $idComLogApi->assembleJsonOrder($order); //organize data into required structure
      
      $count = 0;
      while ($response == false) {
        if ($count >= 50) {
          break;
        } else {
          $response = $idComLogApi->execute($json,'Orders');
          //var_dump($response);die();     
        }
        $count++;  
      }
      
  }*/

  function onAfterOrderUpdate(&$order,&$send_email) {

    $settings = $this->getArtIDComLogApiSettings();
    require JPATH_BASE.'/plugins/hikashop/idcomlogapi/idcomlogapi.class.php';
    $idComLogApi = new IdComLogApi($settings);
    //$idComLogApi->logErrorDB(json_encode($order));
    //var_dump($order);

    if ($order->order_status == 'confirmed') {


        $json = $idComLogApi->assembleJsonOrder($order); //organize data into required structure
        
        $count = 0;
        while ($response == false) {
          if ($count >= 50) {
            break;
          } else {
            $response = $idComLogApi->execute($json,'Orders');
            //var_dump($response);die();     
          }
          $count++;  
        }    
    }

  }

  function getArtIDComLogApiSettings() {
      $db = JFactory::getDBO();
      $sql = "SELECT * FROM `#__artidcomlogapi_settings` WHERE `id`=1";
      $db->setQuery($sql);
      return $db->loadObject();    
  }

}
